=== src/tests/installation/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/installation-scripts.sh ${CMAKE_CURRENT_BINARY_DIR}/installation-scripts.sh COPYONLY)
