=== src/tests/performance/CMakeLists.txt ===
add_subdirectory(psnap)
add_subdirectory(mpi_dist_transpose)
add_subdirectory(BurgersMPI)
