=== debian/changelog ===
open-coarrays (2.0.0~rc1-2) unstable; urgency=medium

  * Adapt watch file to cope with ~rc extension
  * Point VCS at salsa.debian.org

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 26 Feb 2018 11:53:36 +0000

open-coarrays (2.0.0~rc1-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.3; no changes required 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Feb 2018 12:31:48 +0000

open-coarrays (1.9.3-1) unstable; urgency=medium

  * New upstream release
  * Disable test that ICE's under gfortran-7.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Nov 2017 18:24:08 +0000

open-coarrays (1.9.2-2) unstable; urgency=medium

  * Standards-Version: 4.1.1; no changes required
  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Oct 2017 18:15:08 +0100

open-coarrays (1.9.2-1) experimental; urgency=medium

  * New upstream release
  - libcaf_mpi1 changes SONAME to libcaf_mpi2
  - shared_patch merged upstream
  * disable N-S test as linking to staticlib fails
  * Change lib_caf_mpi_static.a to libcaf_mpi.a
  * Standards-Version: 4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 23 Sep 2017 12:33:10 +0100
