## open-coarrays 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -158,6 +158,10 @@
   set( CMAKE_Fortran_COMPILER_VERSION "${DETECTED_VER}" )
 endif()
 
+if(CMAKE_BUILD_TYPE MATCHES "Debug|DEBUG|debug")
+  add_definitions(-DEXTRA_DEBUG_OUTPUT)
+endif()
+
   # We have populated CMAKE_Fortran_COMPILER_VERSION if it was missing
   if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 5.0.0))
     set(opencoarrays_aware_compiler true)
@@ -280,4 +284,3 @@
 else()
   message ( WARNING "MPIEXEC is in \"${MPIEXEC_DIR},\"
 which differs from the location of MPICC and/or MPIFC which are in
-\"${MPICC_DIR}\" and \"${MPIFC_DIR},\" respectively.
