=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(directories_to_build mpi tests)
+set(directories_to_build mpi tests iso-fortran-binding)
 foreach(directory ${directories_to_build})
   add_subdirectory(${directory})
 endforeach()
