=== src/tests/regression/reported/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,13 @@
 caf_compile_executable(co_reduce-factorial-int64 issue-172-wrong-co_reduce-int64.f90)
 caf_compile_executable(source-alloc-sync issue-243-source-allocation-no-sync.f90)
 caf_compile_executable(convert-before-put issue-292-convert-type-before-put.f90)
-caf_compile_executable(issue-493-coindex-slice issue-493-coindex-slice.f90)
 caf_compile_executable(issue-422-send issue-422-send.F90)
 caf_compile_executable(issue-422-send-get issue-422-send-get.F90)
 caf_compile_executable(issue-488-multi-dim-cobounds issue-488-multi-dim-cobounds.f90)
+caf_compile_executable(issue-493-coindex-slice issue-493-coindex-slice.f90)
+caf_compile_executable(issue-503-multidim-array-broadcast issue-503-multidim-array-broadcast.f90)
+caf_compile_executable(issue-503-non-contig-red-ndarray issue-503-non-contig-red-ndarray.f90)
+caf_compile_executable(issue-322-non-coarray-vector-idx-lhs issue-322-non-coarray-vector-idx-lhs.f90)
+if (gfortran_compiler AND (NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0))
+  caf_compile_executable(issue-515-mimic-mpi-gatherv issue-515-mimic-mpi-gatherv.f90)
+endif()
