=== debian/changelog ===
open-coarrays (2.1.0-1build1) cosmic; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:44:16 +0000

open-coarrays (2.1.0-1) unstable; urgency=medium

  * New upstream release
  * Now include IlibISO_Fortran_binding.so.2.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 30 May 2018 15:02:54 +0100

open-coarrays (2.0.0-2) unstable; urgency=medium

  * Build against libopenmpi3
  * Standards-Version: 4.1.4; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 15 Apr 2018 08:57:19 +0100

open-coarrays (2.0.0-1) unstable; urgency=medium

  * New upstream release
  * Build without using mpicc, just caf / pkgconfig
  * Make libcoarrays-dev M-A: same; move includes to /usr/include/$ARCH

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Mar 2018 13:29:39 +0000
