=== debian/control ===
--- 
+++ 
@@ -2,13 +2,15 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 10), dh-buildinfo,
- mpi-default-dev, 
- mpi-default-bin,
+Build-Depends: debhelper (>= 10), 
+ dh-buildinfo,
+ libopenmpi-dev,
+ libmpich-dev,
  cmake (>= 3.3.1), 
  openssh-client,
- gfortran (>= 6.1)
-Standards-Version: 4.1.3
+ gfortran,
+ dh-fortran-mod
+Standards-Version: 4.1.4
 Homepage: https://www.opencoarrays.org/
 Vcs-Browser: https://salsa.debian.org:/science-team/open-coarrays
 Vcs-Git: https://salsa.debian.org:/science-team/open-coarrays.git -b debian/master
@@ -16,6 +18,7 @@
 Package: libcoarrays-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran (>= 6.1-1), mpi-default-bin,
  libcaf-mpi2 (= ${binary:Version})
 Description: Co-Array Fortran libraries for gfortran - development files
